% BUTTERWORTHPOLES gives the poles of a Butterworth filter, turned 
% 90 degrees in the complex plane from what is usually used in 
% filter theory in order to be suitable for use as a mask of a
% distribution function described by simple pole expansions.
%
% poles = BUTTERWORTHPOLES(n,vc)
%
% n:      number of poles
% vc:     absolute value of the poles

function maskpoles = butterworthpoles(n,vc)

maskpoles = vc*exp(1i*pi*([1:2*n]-0.5)/n)';
