% ROOTPATHPLOT plots root paths in the complex phase velocity plane 
%
% ROOTPATHPLOT(vph, UHPpole, lim)
%
% vph:       matrix containing the root paths.
% UHPpoles:  vector containing those poles of the distribution functions
%            that are in the upper half plane.
% lim:       vector containing the solutions in the k=0 limit.

function rootpathplot(vph,UHPpole,lim)

ss = size(vph);

ish = ishold;
hold on
for mode = 1:ss(1)
  plot(vph(mode,:),'k')
end
plot(lim,'k*')
plot(UHPpole,'ko')

if ish
  hold on
else
  hold off
end
